﻿package {
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Stage;
	import flash.ui.Mouse;
	import flash.display.MovieClip;
	import flash.geom.Point;

	public class Branche extends Sprite {

		//PROPRIETES//
		private var _arbre:Arbre;
		private var _generation:Number;
		private var _enfants:Array;
		private var _rotationIni:Number;

		//CONSTRUCTEUR//
		public function Branche(_farbre:Arbre, _fgeneration:Number) {
			
			_arbre = _farbre;
			_generation = _fgeneration;

			//CREATION DE LA FORME//
			var couleur:Array = new Array(0xCCFF00, 0xCCFF22, 0xCCFF44, 0xCCFF66, 0xCCFF88, 0xCCFFAA, 0xCCFFCC, 0xCCFFEE, 0xCCFFFF);

			var rad:Number = (_arbre.generations - _generation) * 2;
			var linelen:Number = (_arbre.generations - _generation) * 4;
			var lineweight:Number = (_arbre.generations - _generation);
			
			this.graphics.moveTo(0,0);
			this.graphics.lineStyle(12, couleur[_generation], 1.0);
			this.graphics.lineTo(0, -linelen);
			
			_rotationIni = Math.floor(Math.random() * 90) - (90/2);
			this.rotation = _rotationIni;
			//FIN CREATION DE LA FORME//
			
			//RECURSIVITE//
			if (_generation < _arbre.generations / 2) {
				_enfants = new Array();
				for (var x:Number = 0; x<_arbre.enfants; x++) {
					//trace(_generation);
					var brancheEnfant:Branche = new Branche(_arbre, _generation + 1);
					brancheEnfant.x = 0;
					brancheEnfant.y = -linelen;
					addChild(brancheEnfant);
					_enfants.push(brancheEnfant);
					}
				}
			//FIN RECURSIVITE//
		}
		
		//METHODE ANIMATION//
		public function maj():void {
			
			const VELOCITE:Number = 10;
			
			//FOIRE AUX ANGLES//
			
			//CONVERSION DES COORDONNEES DE LA BRANCHE DE LOCAL EN GLOBAL//
			var _gloordonnees:Point = localToGlobal(new Point(this.x, this.y));
			var _soordonnees:Point = localToGlobal(new Point(mouseX, mouseY));
			
			//CALCUL DES LONGUEURS//
			var _cop:Number = _gloordonnees.x - _soordonnees.x;
			var _cad:Number = _gloordonnees.y - _soordonnees.y;
			
			//PYTHAGORE//
			var _distance:Number = Math.sqrt(Math.pow(_cop, 2) + Math.pow(_cad, 2));
			var _angleRadians:Number = Math.atan(_cop / _cad);
			var _angleDegres :Number = _angleRadians * 180 / Math.PI;
			
			var _ecart:Number = _angleDegres - this.rotation;
			
			//FIN FOIRE AUX ANGLES//
			
			//RECURSIVITE//
			if (_enfants) {
				for each (var _enfant in _enfants) { _enfant.maj(); }
				}
			//FIN RECURSIVITE//
			
			//ROTATION AVEC UN ECART BASE SUR LA ROTATION INITIALE (SANS IMPORTANCE VU QUE LA ROTATION//
			//EST CALCULEE DEPUIS L'ECART DONC TJRS +OU- ALEATOIRE)//
			//POURRAIT ETRE UNE AUTRE VALEUR, UNE CONSTANTE//
			this.rotation += ( _ecart - _rotationIni ) / VELOCITE;
			}
	}
}